package week11;

import java.sql.SQLOutput;
import java.util.*;
import java.util.function.Predicate;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class StreamMain {
    static class Ruha {
        String szin;
        int meret;

        public Ruha(String szin, int meret) {
            this.szin = szin;
            this.meret = meret;
        }

        public String getSzin() {
            return szin;
        }

        public void setSzin(String szin) {
            this.szin = szin;
        }

        public int getMeret() {
            return meret;
        }

        public void setMeret(int meret) {
            this.meret = meret;
        }

        @Override
        public String toString() {
            return "Ruha{" +
                    "szin='" + szin + '\'' +
                    ", meret=" + meret +
                    '}';
        }
    }
    public static void szures(
            List<Ruha> ruhak,
            Predicate<Ruha> p) {
        ruhak.stream()
                .filter(p)
                .forEach(System.out::println);
        System.out.println();
    }
    public static void main(String[] args) {
        List<Ruha> ruhak = new ArrayList<>();
        ruhak.add( new Ruha("piros", 40));
        ruhak.add( new Ruha("zöld", 42));
        ruhak.add( new Ruha("piros", 38));
        ruhak.add( new Ruha("fehér", 42));
        ruhak.add( new Ruha("fehér", 40));
        ruhak.add( new Ruha("zöld", 42));

        for(var ruha: ruhak) {
            System.out.println(ruha);
        }
        System.out.println();
        Stream<Ruha> ruhaStream = ruhak.stream();
        ruhak.stream().forEach(
                System.out::println
        );
        System.out.println();

        for(var ruha: ruhak) {
            if(ruha.getMeret()==40){
                System.out.println(ruha);
            }
        }
        System.out.println();
        ruhak.stream()
                .filter( ruha -> ruha.getMeret()==40 )
                .forEach(System.out::println);
        System.out.println();

        Predicate<Ruha> negyvenes = ruha -> ruha.getMeret()==40;
        szures(ruhak, negyvenes);
        szures(ruhak, ruha -> ruha.getSzin().equals("piros"));

        //piros ruhák méretét növeljük meg eggyel
        /*ruhak.stream()
                .filter(ruha -> ruha.getSzin().equals("piros"))
                .forEach( ruha -> ruha.setMeret(ruha.getMeret()+1) );
        ruhak.stream()
                .forEach(System.out::println);
        System.out.println();*/

        ruhak.stream()
                .filter(ruha -> ruha.getMeret()==42)
                .map(Ruha::getSzin)
                .forEach(System.out::println);
        System.out.println();

        Set<String> negyvenkettesSzinek = new HashSet<>();
        for(var ruha: ruhak){
            if(ruha.getMeret()==42){
                negyvenkettesSzinek.add(ruha.getSzin());
            }
        }
        System.out.println(negyvenkettesSzinek);

        Set<String> negyvenkettesSzinekStream
                =ruhak.stream()
                .filter(ruha -> ruha.getMeret()==42)
                .map(Ruha::getSzin)
                .collect(Collectors.toSet());
        System.out.println(negyvenkettesSzinekStream);

        //átlagosnál kisebb méretű ruhákat tegyük egy listába
        {
            //ruhak nemüres
            int darab = ruhak.size();
            int sum = 0;
            for(var ruha: ruhak) sum += ruha.getMeret();
            double atlag = (double)sum / darab;
            List<Ruha> kisruhak = new ArrayList<>();
            for(var ruha: ruhak) {
                if(ruha.getMeret() < atlag ){
                    kisruhak.add(ruha);
                }
            }
            System.out.println(atlag);
            System.out.println(kisruhak);
        }
        {
            long darab = ruhak.stream().count();
            int osszeg = ruhak.stream()
                    .mapToInt(Ruha::getMeret)
                    .sum();
            double atlag = (double)osszeg / darab;
            System.out.println(atlag);
            List<Ruha> kisruhak =
                    ruhak.stream()
                    .filter( ruha -> ruha.getMeret() < atlag)
                    .collect(Collectors.toList());
            System.out.println(kisruhak);
        }
        //az első piros ruhát írjuk ki!
        Optional<Ruha> elsoPiros = ruhak.stream()
                .filter(ruha->ruha.getSzin().equals("piros"))
                .findFirst();
        if( elsoPiros.isEmpty() ) {
            System.out.println("Nincs piros ruha!");
        }else{
            System.out.println("Az első piros ruha: " + elsoPiros.get());
        }
        String eredmeny = elsoPiros.map(
                ruha -> "Az első piros ruha: " + ruha)
                .orElse("Nincs piros ruha!");
        System.out.println(eredmeny);

        //ruha színeket String-be konkatenáljuk össze!
        String ruhaszinstring =
                ruhak.stream()
                        .map(Ruha::getSzin)
                .collect(
                        Collectors.joining(",","(",")")
                );
        System.out.println(ruhaszinstring);
    }
}
