package week11;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class TryMainJava {
    private static List<String> parse(String path) {
        List<String> ret = new ArrayList<>();
        try (Scanner scanner = new Scanner(new File(path))) {
            while (scanner.hasNextLine()){
                String line = scanner.nextLine();
                try {
                    int value = Integer.parseInt(line);
                    ret.add( Integer.toString(value * 2 ) );
                }catch (NumberFormatException e) {
                    ret.add("Not an integer: " + line);
                }

            }
        }catch (FileNotFoundException e) {
            ret.add("Not found: "+path);
        }
        return ret;
    }
    public static void main(String[] args) {
        for(String line: parse("src/main/scala/week11/input2.txt")) System.out.println(line);
    }
}
