package week10

import scala.collection.immutable.HashSet

trait Komparable[+K] {
  def compare[U >: K <: Komparable[U]](that: U): Int //negatív: this < that pozitív: this > that 0: this == that
  def <[U >: K <: Komparable[U]](that: U): Boolean = this.compare(that) < 0
  def >[U >: K <: Komparable[U]](that: U): Boolean = this.compare(that) > 0
  def <=[U >: K <: Komparable[U]](that: U): Boolean = this.compare(that) <= 0
  def >=[U >: K <: Komparable[U]](that: U): Boolean = this.compare(that) >= 0
}

case class Pont(x: Int, y: Int) extends Komparable[Pont] {
  override def compare[U >: Pont <: Komparable[U]](that: U): Int = that match {
    case thatPont : Pont =>
      if( this.x != thatPont.x ) this.x - thatPont.x else this.y - thatPont.y
    case _ => -that.compare(this) //TODO this is plain wrong btw
  }
}

trait Keresofa[+K <: Komparable[K]] {
  def contains[U >: K <: Komparable[U]](key: U): Boolean
  def insert[U >: K <: Komparable[U]](key: U): Keresofa[U]
}

case object EmptyTree extends Keresofa[Nothing] {
  override def contains[U >: Nothing <: Komparable[U]](key: U): Boolean = false
  override def insert[U >: Nothing <: Komparable[U]](key: U): Keresofa[U] = NonemptyTree(this, key, this)
}
case class NonemptyTree[K <: Komparable[K]](left: Keresofa[K], key: K, right: Keresofa[K]) extends Keresofa[K] {
  override def contains[U >: K <: Komparable[U]](key: U): Boolean =
    if (this.key == key ) true
    else if (this.key < key ) right.contains(key)
    else left.contains(key)
  override def insert[U >: K <: Komparable[U]](key: U): Keresofa[U] =
    if (this.key == key) this
    else if (this.key < key ) NonemptyTree(left, this.key, right.insert(key))
    else NonemptyTree(left.insert(key),this.key,right)
}

trait Animal extends Komparable[Animal] {
  override def compare[U >: Animal <: Komparable[U]](that: U): Int = that match {
    case thatAnimal : Animal => this.getClass.getName compare that.getClass.getName
    case _ => ???
  }
}

case class Cat(name: String) extends Animal with Komparable[Cat] {
  override def compare[U >: Cat <: Komparable[U]](that: U): Int = that match {
    case thatCat : Cat => this.name compare thatCat.name
    case thatAnimal : Animal => super[Animal].compare(thatAnimal)
  }
}
case class Dog(name: String) extends Animal with Komparable[Dog] {
  override def compare[U >: Dog <: Komparable[U]](that: U): Int = that match {
    case thatDog : Dog => this.name compare thatDog.name
    case thatAnimal : Animal => super[Animal].compare(thatAnimal)
  }
}

object KomparableApp extends App {
  val catset : Set[Animal] = HashSet[Animal]()
  def f(in: Set[Cat]): Int = in.size
}