package week10

sealed trait SuperShape
trait Shape[+T <: SuperShape] extends SuperShape {
  def flip: Shape[T]
}
class Sokszog(x: String) extends Shape[Sokszog]{
  override def flip = new Sokszog(x+x)
  def countSides = x.length
}
case class Negyszog(u: Double, v: Int) extends Sokszog("negy") with Shape[Negyszog] {
  override def flip = Negyszog(2*u,v+1)
}
case class Haromszog(x: Int, y: Int) extends Sokszog("harom") with Shape[Haromszog] {
  override def flip = Haromszog(-x,y)
}
case class Kor(x: Int) extends Shape[Kor] {
  override def flip = Kor(-x)
}

case class ShapeWrapper[+T <: SuperShape](shape: Shape[T], front: Int) {
  def flip: ShapeWrapper[T] = ShapeWrapper(shape.flip, front)
}


object LowerBound extends App {

  def doStuff[T <: Shape[T] ](shapeWrapper: ShapeWrapper[T]) = println("Shape: " + shapeWrapper.shape)

  val haromszog: Shape[Haromszog] = Haromszog(1,2)
  val kor: Shape[Kor] = Kor(2)
  val korWrapper = ShapeWrapper(kor, 3)
  val haromszogWrapper = ShapeWrapper(haromszog, 4)
  val negyszog = Negyszog(1.0,3)
  val negyszogWrapper = ShapeWrapper(negyszog, 1)
  val which = if(true) negyszogWrapper else haromszogWrapper
  val other = which.flip
  val vec = Vector(haromszog, negyszog)
  val wrapperVec = Vector(haromszogWrapper, negyszogWrapper)
  for( x <- vec )
  {
  }
  //which.
  //val vec = Vector(korWrapper,haromszogWrapper)
  //val what = vec(0)
}
