package week11

import scala.concurrent.Future
import scala.io.StdIn
import scala.util.Try
import scala.concurrent.ExecutionContext.Implicits.global

object FutureMain extends App {
  val medNumber: Long =  1125899906842597000L
  val largePrime: Long = 4611686018427387847L

  def factorize(n: Long): (Long, Vector[Long]) = {
    @scala.annotation.tailrec
    def factorize(n: Long, m: Long, acc: Vector[Long]): Vector[Long] =
      if(n <= 1) acc
      else if(n%m == 0) factorize(n/m, m, acc :+ m )
      else if(m*m > n) acc :+ n
      else factorize(n, m+1, acc)
    (n,factorize(n,2,Vector()))
  }

  def processLong(value: Long): Unit = {
    for( pair <- Future(factorize(value)) ) {
      showResult(value, pair._2)
    }
  }
////------------------------------------------------------
  def showResult(n: Long, factors: Vector[Long]): Unit = {
    println("The factorization of " + n + " is " + factors.mkString(" * " ))
  }

  def processInput(line: String): String = {
    val tryLong = Try(line.toLong)
    tryLong.map{
      value => processLong(value) ; "Integer: "+value }
      .getOrElse("Not an integer: " + line)
  }

  @scala.annotation.tailrec
  def mainLoop(): Unit = {
    println("Please enter an integer to factorize, or Q to quit.")
    val line = StdIn.readLine()
    line.trim.toUpperCase match {
      case "Q" => println("Ok. Bye!"); ()
      case _   => println(processInput(line)); mainLoop();
    }
  }

  mainLoop()

}
