package week11

import scala.io.Source
import scala.util.{Failure, Success, Try}

object TryMain extends App {

  def parseList(input: Iterator[String]): List[String] = {
    input.map( line => Try( (line.toInt * 2).toString ).recover{
      case _ : NumberFormatException => "Not an integer: " + line
    }.get ).toList
  }

  def divider(n: Int, m: Int): Try[Int] = Try( n / m )

  def parse(path: String): List[String] = {
    val trySource: Try[Source] = Try(Source.fromFile(path))
    val tryLines: Try[Iterator[String]] = trySource.map( _.getLines() )
    val ret = tryLines.map( parseList(_) ).getOrElse( List("File not found: " + path))
    trySource.foreach( _.close() )
    ret
  }

  //parse("src/main/scala/week11/input.txt") foreach println
  val x = divider(3,0)
  println(x)

}
