package week12

import java.io._
import java.util.Scanner

import scala.io.Source
import scala.util.Try

case class Ember(id: String, vezeteknev: String, keresztnev: String, nick: String, szint: Int)

/**
 * Ellenőrizzük műkincs konstruálásakor, hogy
 * - a méret pozitív legyen -- ha nem az, dobjunk IllegalArgumentExceptiont
 * - az érték nemnegatív legyen -- ha nem az, állítsuk nullára
 */
case class Mukincs(id: String, nev: String, meret: Int, ertek: Int)

object Mukincs {
  def apply(id: String, nev: String, meret: Int, ertek: Int): Mukincs = {
    println("hello")
    require(meret > 0)
    println("world")
    new Mukincs(id,nev,meret,ertek)
  }
}
case class Lada(id: String, emberId: String, meret: Int, tartalom: Vector[Mukincs]) {
  /**
   * Írjunk metódust, mely visszaadja, hogy az adott műkincs belefér-e még a ládába.
   */
  def canFit(mukincs: Mukincs): Boolean = ???

  /**
   * Írjunk metódust, ami belepakolja a paraméterként adott műkincset a ládába, ha tudja,
   * és visszaadja az új ládát egy Optionben; ha nem tudja, adjon vissza None-t.
   */
  def push(mukincs: Mukincs): Option[Lada] = ???
}

case class Saver(writer: PrintWriter) {
  def save(mukincs: Mukincs): Try[Unit] = {
    Try(writer.write(mukincs.productIterator.mkString(";")))
  }
  def save(lada: Lada): Try[Unit] = {
    val ladaPrinted = Try(writer.write(s"${lada.id};${lada.emberId};${lada.meret}"))
    lada.tartalom.foldLeft( ladaPrinted ) {
      (acc,mukincs) => acc.map( _ => writer.print(";")).flatMap( _ => save(mukincs) )
    }
  }
  def save(ember: Ember): Try[Unit] = {
    Try(writer.write(ember.productIterator.mkString(";")))
  }
  def save(embers: Iterable[Ember], ladas: Iterable[Lada]): Try[Unit] = {
    val tryHeader = Try(writer.println("Emberek"))
    val embersSaved = embers.foldLeft( tryHeader ) {
      (acc, ember) => for( _ <- acc; _ <- save(ember) ) yield writer.println()
    }
    val tryHeader2 = embersSaved.map( _ => writer.println("Ládák") )
    val ladasSaved = ladas.foldLeft( tryHeader2 ) {
      (acc, lada) => for( _ <- acc; _ <- save(lada) ) yield writer.println()
    }
    ladasSaved
  }
}

object Optimizer {

  /**
   * Írjunk metódust, ami a bejövő ládákat kiüríti: az output első komponensébe
   * a bejövő ládák kerüljenek "üresen", a másodikba pedig az összes eredetileg
   * bennük lévő műkincs!
   */
  def kiuritLadak(ladak: Iterable[Lada]): (Vector[Lada], Vector[Mukincs]) = ???

  /**
   * Írjunk metódust, ami a bejövő műkincsek vektorát ár/érték arány szerint
   * csökkenő sorrendben adja vissza!
   * (tehát pl egy 5 méretű 10 értékű, aminek a fajlagos értéke 10/5 = 2,
   * előbb szerepeljen, mint egy 3 méretű 5 értékű, aminek a fajlagos értéke
   * csak 5/3.)
   */
  def mukincsRendez(mukincsek: Vector[Mukincs]): Vector[Mukincs] = ???

  /**
   * Írjunk metódust, ami a bejövő ládák vektorából visszaadja
   * a legnagyobb méretűt! Ha üres az input vektor, legyen None.
   */
  def legnagyobbLada(ladak: Vector[Lada]): Option[Lada] = ???

  /**
   * írjunk metódust, ami a bejövő üres ládák és műkincsek vektorából a legnagyobb ládát
   * megtölti mohó módon a fajlagosan legdrágább, majd a második legdrágább, ... amíg fér
   * műkincsekkel!
   * A visszaadott vektorokban az új ládák legyenek (egy nemüres, többi üres), és a kimaradó műkincsek.
   * Ha van nemüres láda az inputban, faileljünk IllegalArgumentExceptionnel.
   */
  def ertekesLadatGyart(ladak: Iterable[Lada], mukincsek: Vector[Mukincs]): Try[(Vector[Lada], Vector[Mukincs])] = ???

  /**
   * Írjunk metódust, ami a bejövő üres ládák és műkincsek vektorából a legnagyobb
   * ládát megtölti műkincsekkel úgy, hogy garantáltan a lehető legnagyobb legyen
   * az össz értéke a műkincseknek!
   * Nem baj, ha lassú lesz.
   */
  def legertekesebbLadatGyart(ladak: Iterable[Lada], mukincsek: Vector[Mukincs]): Try[(Vector[Lada], Vector[Mukincs])] = ???

  /**
   * Írjunk metódust, ami a bejövő ládák sorozatát "átpakolással" optimalizálja:
   * minél több ládát ürítsen ki! Figyelve a ládák kapacitását persze.
   */
  def optimizeLadak(ladak: Iterable[Lada]):Vector[Lada] = ???
}

/**
 * Írjuk meg a Saver mintájára a Source-ből olvasó Loader-t is!
 */
case class Loader(source: Source) {
  def loadMukincs(scanner: Scanner): Try[Mukincs] = ???
  def loadLada(line: String): Try[Lada] = ??? //láda loadnál figyeljünk arra is, hogy faileljen el, ha túl sok műkincset akarunk belerakni
  def loadEmber(line: String): Try[Ember] = ???
  def loadFile(): (Vector[Ember], Vector[Lada], Vector[Exception]) = ??? //gyűjtsük le az összes érkező kivételt is egy vektorba
}

object Gyakorlat extends App {
  val path = "src/main/scala/week12/save2.txt"
  val ember1 = Ember("007", "Bond", "James", "sanyi", 17)
  val ember2 = ember1.copy(id = "008", keresztnev = "John", szint = 15)
  val mk1 = Mukincs("mk01", "Mona Liza", 4, 100)
  val mk2 = Mukincs("mk02", "Fake Mona Liza", 4, 1)
  val lada = Lada("lada01", "008", 10, Vector(mk1,mk2))


  val tryWriter = Try(new PrintWriter(path))
  val printedHeader = tryWriter.flatMap( writer => Saver(writer).save(Vector(ember1,ember2), Vector(lada)))
  tryWriter.map( _.close() )
  println(printedHeader)
}
