package week13

import java.io.PrintWriter

import scala.util.Try

/**
 * A feladat: színes dobozokat pakolunk egymásba.
 * Egy doboznak (Doboz) van
 * - külső mérete (kivul: Int)
 * - belső mérete (belul: Int), persze belul < kivul
 * - színe        (szin: String)
 * - tartalma     (tartalom: Vector[Doboz])
 * Egy dobozban közvetlenül tartalmazott dobozok össz külső mérete legfeljebb akkora lehet, mint a tartalmazó doboz belső mérete.
 * Pl. egy 8-as belső mérettel rendelkező dobozban lehet 2 darab 3-as külső mérettel rendelkező doboz, de 3 már nem.
 *
 * ha valamelyik teszteset szerintetek hibás, a feladat beadásakor coospacen jelezzétek!
 * Beadandó ez a ZH.scala file, a src/main/scala/week13/ mappában van.
 */

/**
 * Egészítsük ki a Doboz osztályt a következőkkel:
 * - ha a szín üres string, dobjon IllegalArgumentException-t
 * - ha a külső méret kisebb, mint 1, dobjon IllegalArgumentException-t
 * - ha a belső méret kisebb, mint 0, akkor állítsa be 0-ra
 * - ha a belső méret nagyobb, mint a külső, akkor állítsa be külső-1 -re
 * - ha a tartalom elemeinek külső méreteinek összege nagyobb, mint a belső méret, dobjon IllegalArgumentException-t
 */
case class Doboz(kivul: Int, belul: Int, szin: String, tartalom: Vector[Doboz]) {
  /**
   * Írjunk egy kimaradoHely metódust, ami visszaadja, hogy még mennyi üres hely van ebben a dobozban!
   * (tehát pl ha a doboz belső mérete 8, és van benne két 3 külső méretű doboz, akkor adjon vissza 2-t.)
   */
  def kimaradoHely: Int = ???

  /**
   * Írjunk egy osszesKimaradoHely metódust, ami visszaadja, hogy a dobozban és a benne tartalmazott összes
   * dobozban együttesen még mennyi üres hely van!
   * (tehát pl ha a doboz belső mérete 8, és van benne két 3 külső méretű doboz, amiknek a belső méretük 2-2,
   * és az egyikben közülük van egy 1 külső méretű, 0 belső méretű doboz, akkor adjon vissza 2 + 1 + 0 + 2 = 5-öt.)
   */
  def osszesKimaradoHely: Int = ???

  /**
   * Írjunk egy foreach metódust, ami a paraméterként kapott függvényt végrehajtja a dobozon és a benne tartalmazott
   * összes dobozon!
   * (tehát pl ha a dobozban van két doboz és közülük az elsőben még egy doboz, akkor mind a négy dobozon végrehajtja
   * a kapott f függvényt).
   */
  def foreach[U](f: Doboz=>U): Unit = ???

  /**
   * Írjunk egy filter metódust, ami készít egy másik dobozt, ami a doboz-kollekciónkból pontosan azokat a dobozokat
   * tartja csak meg, melyekre igaz a predikátum, amikre nem igaz, azokat (a bennük lévő többi dobozzal együtt (!) )
   * eldobja!
   *
   * Tehát pl. a filter( _.szin == "Piros" ) hívása akkor, ha egy piros dobozban van egy zöld, abban egy piros,
   * és a felső szintű piros dobozban van még egy kisebb piros és egy kisebb kék doboz, akkor visszatér
   * egy Some értékkel, amiben az eredeti nagy piros dobozunk és a közvetlenül benne levő kisebb piros doboz van).
   * Ha már a külső dobozra se igaz a feltétel (és ezért doboz nélkül térnénk vissza), adjunk vissza None-t!
   */
  def filter(p: Doboz=>Boolean): Option[Doboz] = ???

  /**
   * Írjunk olyan függvényt, ami a dobozt és minden tartalmazott dobozát (nem csak a közvetleneket)
   * átállítja a paraméterként megadott színűre! (funkcionálisan, azaz nem változtatva persze az eredeti dobozt,
   * hanem visszadva egy új doboz-együttest, amiben minden doboz a megadott színű.)
   */
  def paintThemAll(szin: String): Doboz = ???

  /**
   * Írjunk olyan függvényt, ami visszaad egy Set[String]-et, amiben a doboz és összes aldobozának a színei szerepelnek!
   */
  def colors: Set[String] = ???
}

/**
 * Írjunk egy olyan text file-ba mentő kódot, ami a következő módon ment el egy dobozt:
 * [ kivul;belul;szin
 * tartalmazott első doboz ugyanígy
 * tartalmazott második doboz ugyanígy
 * ...
 * tartalmazott utolsó doboz ugyanígy
 * ]
 *
 * azaz pl.
 *
 * [ 10;9;Piros
 * [ 3;2;Zöld
 * ]
 * [ 4;3;Piros
 * [ 2;1;Kék
 * ]
 * ]
 * ]
 *
 * lenne a writer-be kiírt tartalom akkor, ha egy 10 külső és 9 belső méretű piros dobozban van egy zöld és egy piros
 * doboz (a jelzett méretekkel), és a belső pirosban még egy kék is.
 *
 * Ha sikerült kiírnunk a tartalmat, egy Success(()), ha nem, egy, a kivételt tartalmazó Failure jöjjön vissza.
 */
case class DobozSaver(writer: PrintWriter) {
  def save(doboz: Doboz): Try[Unit] = ???
}


object ZH extends App {
  /**
   * Ide bátran lehet lokális teszteket írni, ha szükséges
   */
}
